GEN23.csd
Written by Iain McCurdy, 2011

<CsoundSynthesizer>

<CsOptions>
-odac -dm0
</CsOptions>

<CsInstruments>

sr 	= 	44100
ksmps 	= 	8
nchnls 	= 	1
0dbfs	=	1

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FLcolor	255, 255, 255, 0, 0, 0	;SET INTERFACE COLOURS
;					WIDTH | HEIGHT | X | Y
		FLpanel	"GEN23", 	500,      70,    0,  0
;SWITCHES                       				ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff		FLbutton	"Start/Stop",		1,    0,    22,    150,     30,   10, 10,    0,      1,      0,      -1
FLsetColor2	255, 255, 50, ihOnOff		;SET SECONDARY COLOUR TO YELLOW

;COUNTERS					     	MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X | Y | OPCODE 
gkpatt, ihpatt		FLcount  	"Pattern", 	1,      3,    1,      1,      2,    150,     30,   175, 10,   -1
gktempo, ihtempo	FLcount  	"Tempo", 	30,   500,    1,     10,      1,    150,     30,   340, 10,   -1

;SET INITIAL VALUES OF FLTK VALUATORS
		FLsetVal_i	1,ihpatt
		FLsetVal_i	90,ihtempo

		FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 		WIDTH | HEIGHT | X | Y
				FLpanel	"info.", 	500,     340,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                            GEN23                            ", 	1,      5,     14,    490,    15,     5,   0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"GEN23 allows us to read discreet numerical data from a text  ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"file into a function table in the manner in which individual ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"values are built into a GEN02 function table.                ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"Individual values within the text file can be separated by   ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"spaces, tabs or newlines.                                    ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"GEN23 can be used in places where GEN02 might be used. Its   ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"advantage might be that each table can be stored in unique   ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"and separate documents with additional formatting. A table   ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"(text document) could be shared by shared several csound csds", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"so that editing the text document once will alter its        ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"resulting function table in all linking csds.                ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"In this example GEN23 function tables are created from text  ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"documents which are used as drum sequencer pattern data. This", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"way banks of patterns could be stored independently of any   ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"particular Csound csd.                                       ", 	1,      5,     14,    490,    15,     5, 320

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine		ftgen		0,0,4096,10,1	;A SINE WAVE
gipatt1		ftgen 		0,0,128,-23,"pattern1"	;PHRASE FROM EXTERNAL TEXT FILE
gipatt2		ftgen 		0,0,128,-23,"pattern2"	;PHRASE FROM EXTERNAL TEXT FILE
gipatt3		ftgen 		0,0,128,-23,"pattern3"	;PHRASE FROM EXTERNAL TEXT FILE

instr	1	;NOTE TRIGGERING INSTRUMENT
	if gkOnOff=0 then				;IF ON/OFF SWITCH IS OFF...
	  turnoff					;TURN THIS INSTRUMENT OFF IMMEDIATELY
	endif						;END OF THIS CONDITIONAL BRANCH
	kBPS	=	gktempo/60			;DERIVE BEATS-PER-SECOND 
	kreinit	changed	gkpatt				;IF ONE OF THE INPUT ARGUMENTS CHANGES GENERATE A MOPMENTARY 1 IN THE OUTPUT ARGUMENT
	if kreinit==1 then				;IF A REINITIALISATION TRIGGER HAS BEEN GENERATED...
	  reinit	UPDATE				;...BEGIN A REINITIALISATION PASS FROM LABEL 'UPDATE'
	endif						;END OF THIS CONDITIONAL BRANCH
	UPDATE:						;LABEL CALLED 'UPDATE'. REINITIALISATION PASS BEGINS FROM HERE.
	ipatt		init	gipatt1+i(gkpatt)-1	;CHOOSE PATTERN DERIVED FROM FLTK COUNTER
	ibeats		init	4			;NUMBER OF BEATS IN LOOP
	kphase   	phasor  kBPS/ibeats		;DEFINE PHASOR ACCORDING TO BEATS-PER-SECOND AND NUMBER OF BEAT IN PHRASE
	kpointer	=	kphase * ibeats		;MULTIPLY PHASE VALUE BY NUMBER OF BEATS
	kp1		init	0			;INITIALISE P-FIELD VARIABLES
	kp2		init	0       		;INITIALISE P-FIELD VARIABLES
	kp3		init	0       		;INITIALISE P-FIELD VARIABLES
	kp4		init	0       		;INITIALISE P-FIELD VARIABLES
	ktrigger   timedseq kpointer, ipatt, kp1, kp2,kp3,kp4	;READ CURRENT TRIGGER AND P-FIELDS FROM FUNCTION TABLE
	rireturn					;RETURN FROM REINITIALISATION PASS
		schedkwhen ktrigger,0,0,kp1,0,kp3,kp4	;TRIGGER A NOTE
endin

instr	2						;SOUND 1 - BASS DRUM
	iamp	random	0.4, 0.5			;AMPLITUDE RANDOMLY CHOSEN FROM BETWEEN THE GIVEN VALUES
	p3	=	0.2				;DEFINE DURATION FOR THIS SOUND
	aenv	line	1,p3,0.001			;AMPLITUDE ENVELOPE - PERCUSSIVE DECAY
	icps	exprand	30				;CYCLES-PER-SECOND OFFSET RANDOMLY CHOSEN FROM AN EXPONENTIAL DISTRIBUTION
	kcps	expon	icps+120,p3,20			;PITCH GLISSANDO
	asig	oscil	aenv*0.5*iamp*p4, kcps, gisine	;OSCILLATOR
		out	asig				;SEND AUDIO TO OUTPUTS
endin

instr	3						;SOUND 3 - SNARE
	iamp	random	0.4, 0.5			;AMPLITUDE RANDOMLY CHOSEN FROM BETWEEN THE GIVEN VALUES
	p3	=	0.3				;DEFINE DURATION FOR THIS SOUND
	aenv	expon	1, p3, 0.001			;AMPLITUDE ENVELOPE - PERCUSSIVE DECAY
	anse	noise	1, 0				;CREATE NOISE COMPONENT FOR SNARE DRUM SOUND	
	icps	exprand	5				;CYCLES-PER-SECOND OFFSET RANDOMLY CHOSEN FROM AN EXPONENTIAL DISTRIBUTION
	kcps	expon	250 + icps, p3, 200+icps	;CREATE TONE COMPONENT FREQUENCY GLISSANDO FOR SNARE DRUM SOUND
	ajit	randomi	0.2, 1.8, 10000			;JITTER ON FREQUENCY FOR TONE COMPONENT
	atne	oscil	aenv, kcps*ajit, gisine		;CREATE TONE COMPONENT
	asig	sum	anse*0.1, atne			;MIX NOISE AND TONE SOUND COMPONENTS
	ares	comb	asig, 0.02, 0.0035		;PASS SIGNAL THROUGH A COMB FILTER TO CREATE STATIC HARMONIC RESONANCE
	asig	=	ares * aenv * iamp*p4		;APPLY ENVELOPE AND AMPLITUDE FACTOR TO SOUND
		out	asig				;SEND AUDIO TO OUTPUTS
endin                                                                                     
                                               
instr 4							;SOUND 4 - CLOSED HI-HAT
	iamp	random	1.2, 1.5			;AMPLITUDE RANDOMLY CHOSEN FROM BETWEEN THE GIVEN VALUES
	p3	=	0.1				;DEFINE DURATION FOR THIS SOUND
	aenv	expon	1,p3,0.001			;AMPLITUDE ENVELOPE - PERCUSSIVE DECAY
	asig	noise	aenv, 0				;CREATE SOUND FOR CLOSED HI-HAT
	asig	buthp	asig*0.6*iamp*p4, 12000		;HIGHPASS FILTER SOUND
	asig	buthp	asig,          12000		;HIGHPASS FILTER SOUND AGAIN TO SHARPEN CUTOFF
		out	asig				;SEND AUDIO TO OUTPUTS
endin

</CsInstruments>  

<CsScore>
f 0 3600
</CsScore>

</CsoundSynthesizer>